///////////////////////////////////////////////////////////////////////////////
// File:       A4.java
//
// Assignment: Assignment 4: Tree-Tree-Tree Unit
// Course:     CS367, Spring 2004
// Date:       4/30/04
//
// Student:    Justin Fiedler
// Lecture:    2:30 - 3:45 TR
// CS Login:   fiedler
///////////////////////////////////////////////////////////////////////////////

import java.io.*;

/**
 * Class that allows files to be read into a BSTree and displays the height, 
 * the tree, and 3 traversals 
 *
 * <p>Bugs: none
 *
 * @author Justin Fiedler
 */	
public class A4
{	private BSTree bst; 

	public A4(String[] args)
	{	bst = new BSTree();
	
		for ( int i=0; i < args.length; i++ ) 
			processFile( args[i] );
		
		System.out.println(bst.getHeight());
		bst.printTree();
		System.out.println("In-order Traversal:   " + bst.inorderTraversal());
		System.out.println("Pre-order Traversal:  " + bst.preorderTraversal());
		System.out.println("Post-order Traversal: " + bst.postorderTraversal());
	}
	
	/**
	 * The main method creates a new A4 with args from user
	 * 
	 * @param args the String of filenames for to use for trees
	 */
	public static void main ( String [] args ) throws IOException
	{   new A4(args);
	}

	/**
	 * Takes the name of the file to use as input and reads the data into the
	 * tree.
	 * 
	 * @param filename the name of the file to process
	 */
	private void processFile( String filename )
	{   String token = null;
	    try
	    {	SourceFileTokenizer sft = new SourceFileTokenizer(filename);
			while(true)
			{   token = sft.nextSourceToken();
			    if(token == null) break;
			    bst.insertItem(token);
			}
	    }
	    catch(FileNotFoundException e)
	    {
	    }
	    catch(IOException e)
	    {	System.out.println("Bad File Format");
	    	System.exit(1);
	    }
	}
}
